package compute

import (
	"context"
	"net/http"
	"strings"

	"repository.basistech.ru/BASIS/decort-golang-sdk/internal/validators"
)

// MigrateAbortRequest struct to abort migration
type MigrateAbortRequest struct {
	// ID of the compute instance
	// Required: true
	ComputeID uint64 `url:"compute_id" json:"compute_id" validate:"required"`
}

type wrapperMigrateAbortRequest struct {
	MigrateAbortRequest

	AsyncMode bool `url:"asyncMode"`
}

// MigrateAbort aborts compute migration
func (c Compute) MigrateAbort(ctx context.Context, req MigrateAbortRequest) (string, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return "", validators.ValidationErrors(validators.GetErrors(err))
	}

	reqWrapped := wrapperMigrateAbortRequest{
		MigrateAbortRequest: req,
		AsyncMode:           false,
	}

	url := "/cloudbroker/compute/migrate_abort"

	res, err := c.client.DecortApiCall(ctx, http.MethodPost, url, reqWrapped)
	if err != nil {
		return "", err
	}

	result := strings.ReplaceAll(string(res), "\"", "")

	return result, nil
}

// MigrateAbortAsync aborts compute migration with AsyncMode
func (c Compute) MigrateAbortAsync(ctx context.Context, req MigrateAbortRequest) (string, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return "", validators.ValidationErrors(validators.GetErrors(err))
	}

	reqWrapped := wrapperMigrateAbortRequest{
		MigrateAbortRequest: req,
		AsyncMode:           true,
	}

	url := "/cloudbroker/compute/migrate_abort"

	res, err := c.client.DecortApiCall(ctx, http.MethodPost, url, reqWrapped)
	if err != nil {
		return "", err
	}

	return string(res), nil
}
